renoise.tool():add_keybinding {name="Global:Commando:Switch Note/Effect Column", invoke = function() switchcolumns() end}
renoise.tool():add_keybinding {name="Global:Commando:Kill Effect", invoke = function() killFx() end}
renoise.tool():add_keybinding {name="Global:Commando:Effect Parameter +1", invoke = function() editParam(1) end}
renoise.tool():add_keybinding {name="Global:Commando:Effect Parameter -1", invoke = function() editParam(-1) end}
renoise.tool():add_keybinding {name="Global:Commando:Effect Parameter +16", invoke = function() editParam(16) end}
renoise.tool():add_keybinding {name="Global:Commando:Effect Parameter -16", invoke = function() editParam(-16) end}

renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0A", invoke = function() insertCommand("0A") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0U", invoke = function() insertCommand("0U") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0D", invoke = function() insertCommand("0D") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0G", invoke = function() insertCommand("0G") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0I", invoke = function() insertCommand("0I") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0O", invoke = function() insertCommand("0O") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0C", invoke = function() insertCommand("0C") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0M", invoke = function() insertCommand("0M") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0S", invoke = function() insertCommand("0S") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0B", invoke = function() insertCommand("0B") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0R", invoke = function() insertCommand("0R") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0Y", invoke = function() insertCommand("0Y") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0V", invoke = function() insertCommand("0V") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0T", invoke = function() insertCommand("0T") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0N", invoke = function() insertCommand("0N") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0E", invoke = function() insertCommand("0E") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0W", invoke = function() insertCommand("0W") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0J", invoke = function() insertCommand("0J") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0X", invoke = function() insertCommand("0X") end}

renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0L", invoke = function() insertCommand("0L") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0P", invoke = function() insertCommand("0P") end}
renoise.tool():add_keybinding {name="Global:Commando:Insert Command 0Q", invoke = function() insertCommand("0Q") end}

--Switch between Effect and Note Column (nicked from Paketti by Esa Ruoho and Pr0tman)
--[sh+alt] + ENTER
function switchcolumns()
	local s = renoise.song()
	local w = renoise.app().window
	if 
		s.selected_note_column_index==nil 
	then 
		return
	else
		if 
			s.selected_effect_column_index==1
		then 
			s.selected_note_column_index=1
			w.active_middle_frame=1
			w.lock_keyboard_focus=true
		else 
			s.selected_effect_column_index=1
			w.active_middle_frame=1
			w.lock_keyboard_focus=true
		end
	end
end

--Remote effect parameter edit
--[sh+alt] + CRSR
function editParam(amount)
	local s = renoise.song()
	local oldValue = nil
	local newValue = nil
	oldValue = s.patterns[s.selected_pattern_index].tracks[s.selected_track_index].lines[s.selected_line_index].effect_columns[1].amount_value
	newValue = oldValue+amount
	if
		newValue > 255
	then
		newValue = newValue - 255
	else
		if
			newValue < 0
		then
			newValue = newValue + 255
		end
	end
	s.patterns[s.selected_pattern_index].tracks[s.selected_track_index].lines[s.selected_line_index].effect_columns[1].amount_value=newValue
end

--Delete effect
--[sh+alt] + DEL
function killFx()
	local s = renoise.song()
	s.patterns[s.selected_pattern_index].tracks[s.selected_track_index].lines[s.selected_line_index].effect_columns[1].number_string="00" 
	s.patterns[s.selected_pattern_index].tracks[s.selected_track_index].lines[s.selected_line_index].effect_columns[1].amount_value=0
end

--Insert Command
--[sh+alt+ctrl] + [command letter]
function insertCommand(cmnd)
	local s = renoise.song()
	s.patterns[s.selected_pattern_index].tracks[s.selected_track_index].lines[s.selected_line_index].effect_columns[1].number_string=cmnd
end